﻿Imports C1.WPF.C1Chart
Imports System.Windows.Controls.Primitives

Class MainWindow
    
    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        CreateSampleData()
    End Sub

    Private Sub CreateSampleData()
        Dim chartDataChildren As DataSeriesCollection = New DataSeriesCollection
        Dim npts As Integer = 10
        Dim x() As Double = New Double(npts) {}
        Dim y() As Double = New Double(npts) {}

        For i = 0 To 9
            x(i) = (i + 1) * 50
            y(i) = (i + 1) * 100
        Next
        Dim XY As New XYDataSeries
        XY.Label = "S1"
        XY.XValuesSource = x
        XY.ValuesSource = y
        Chart1.Data.Children.Add(XY)
    End Sub

    Private Sub Chart1_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Chart1.MouseLeftButtonDown
        Chart1.Focus()
    End Sub

    Private Sub UpdateScrollbars()
        Dim sx As Double = Chart1.View.AxisX.Scale
        Dim sbx As AxisScrollBar = CType(Chart1.View.AxisX.ScrollBar, AxisScrollBar)
        If sx >= 1.0 Then
            sbx.Visibility = Visibility.Collapsed
        Else
            sbx.Visibility = Visibility.Visible
        End If

        Dim sy As Double = Chart1.View.AxisY.Scale
        Dim sby As AxisScrollBar = CType(Chart1.View.AxisY.ScrollBar, AxisScrollBar)
        If sy >= 1.0 Then
            sby.Visibility = Visibility.Collapsed
        Else
            sby.Visibility = Visibility.Visible
        End If
    End Sub

    Private Sub Chart1_PreviewKeyDown(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles Chart1.PreviewKeyDown
        Chart1.View.AxisX.MinScale = 0.001
        Chart1.View.AxisY.MinScale = 0.001

        If e.Key = Key.Down Then
            Chart1.BeginUpdate()
            Chart1.View.AxisX.Scale = Chart1.View.AxisX.Scale - 0.35
            Chart1.View.AxisY.Scale = Chart1.View.AxisY.Scale - 0.35
            UpdateScrollbars()
            Chart1.EndUpdate()
        ElseIf e.Key = Key.Up Then
            Chart1.BeginUpdate()
            Chart1.View.AxisX.Scale = Chart1.View.AxisX.Scale + 0.35
            Chart1.View.AxisY.Scale = Chart1.View.AxisY.Scale + 0.35
            UpdateScrollbars()
            Chart1.EndUpdate()
        ElseIf e.Key = Key.Escape Then
            Chart1.BeginUpdate()
            Chart1.View.AxisX.Scale = 1
            Chart1.View.AxisY.Scale = 1
            UpdateScrollbars()
            Chart1.EndUpdate()
        End If
    End Sub
End Class
